import subprocess
import os
from autosubmit.config.log import Log


class CDFTools:

    def __init__(self, path=''):
        self.path = path

    # noinspection PyShadowingBuiltins
    def run(self, command, input, output=None, options=None, log_level=Log.DEBUG):
        line = [os.path.join(self.path, command)]
        if input:
            if isinstance(input, basestring):
                line.append(input)
            else:
                for element in input:
                    line.append(element)
        if options:
            for option in options:
                line.append(option)
        if output:
            if input == output:
                raise Exception('Input and output file can not be the same on CDFTools')
            line.append('-o')
            line.append(output)
        Log.debug('Executing {0}', ' '.join(line))
        process = subprocess.Popen(line, stdout=subprocess.PIPE)
        for line in process.communicate():
            if not line:
                continue
            Log.log.log(log_level, line)

